VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StdShell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event ConsoleOutput(ByVal Output As String)
Attribute ConsoleOutput.VB_Description = "Fires when output it sent through stdout."
Attribute ConsoleOutput.VB_MemberFlags = "200"
Public Event ConsoleError(ByVal Output As String)
Attribute ConsoleError.VB_Description = "Fires when output is sent through stderror."
Public Event ProcessComplete(ByVal ExitCode As Long)
Attribute ProcessComplete.VB_Description = "Fires when the shelled application has completed and passes the exit code from the process."
Public Event Error(ByVal ErrorNumber As Long, ByVal ErrorMessage As String)
Attribute Error.VB_Description = "Fires when there is an error initializing the library or shelling the console application."

Private Const STARTF_USESHOWWINDOW = &H1
Private Const STARTF_USESTDHANDLES = &H100
Private Const SW_HIDE = 0
Private Const CREATE_NO_WINDOW = &H8000000
Private Const INFINITE = -1
Private Const WAIT_TIMEOUT = 258&
Private Const WAIT_OBJECT_0 = 0&
Private Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Private Const FORMAT_MESSAGE_IGNORE_INSERTS = &H200

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Private Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Private Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type

Private Type StdPipe
    hReadPipe As Long
    hWritePipe As Long
End Type

Private Declare Function CreatePipe Lib "kernel32" (phReadPipe As Long, phWritePipe As Long, lpPipeAttributes As SECURITY_ATTRIBUTES, ByVal nSize As Long) As Long
Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As Any) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As Any) As Long
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, lpProcessAttributes As SECURITY_ATTRIBUTES, lpThreadAttributes As SECURITY_ATTRIBUTES, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Function PeekNamedPipe Lib "kernel32" (ByVal hNamedPipe As Long, lpBuffer As Any, ByVal nBufferSize As Long, lpBytesRead As Long, lpTotalBytesAvail As Long, lpBytesLeftThisMessage As Long) As Long

Private lngRunning As Long
Private strCommand As String
Attribute strCommand.VB_VarHelpID = -1
Private strStdIn As String
Private pi As PROCESS_INFORMATION
Private stdOut As StdPipe
Private stdIn As StdPipe
Private stdError As StdPipe

Public Function Execute(ByVal CommandString As String) As Boolean
Attribute Execute.VB_Description = "Shells the specified console application."
Dim si As STARTUPINFO
Dim sa As SECURITY_ATTRIBUTES

    If lngRunning = 0 Then
        strCommand = CommandString
        sa.nLength = Len(sa)
        sa.bInheritHandle = True
        sa.lpSecurityDescriptor = 0
        If CreatePipe(stdOut.hReadPipe, stdOut.hWritePipe, sa, 0) And CreatePipe(stdIn.hReadPipe, stdIn.hWritePipe, sa, 0) And CreatePipe(stdError.hReadPipe, stdError.hWritePipe, sa, 0) Then
            si.cb = Len(si)
            si.dwFlags = STARTF_USESHOWWINDOW Or STARTF_USESTDHANDLES
            si.wShowWindow = SW_HIDE
            si.hStdError = stdError.hWritePipe
            si.hStdOutput = stdOut.hWritePipe
            si.hStdInput = stdIn.hReadPipe
            If CreateProcess(vbNullString, strCommand, sa, sa, True, CREATE_NO_WINDOW, ByVal 0, vbNullString, si, pi) Then
                lngRunning = SetTimer(0, 0, 50, AddressOf Background.TimerProc)
                colTimers.Add ObjPtr(Me), "tmr" & CStr(lngRunning)
                Execute = True
            Else
                RaiseError Err.LastDllError
                Execute = False
            End If
        End If
    Else
        RaiseEvent Error(vbObjectError + 1, "Process already running.")
    End If
End Function

Public Sub WriteConsole(ByVal CommandString As String)
Attribute WriteConsole.VB_Description = "Write information through stdin to the console application"

    strStdIn = strStdIn & CommandString
End Sub

Public Function Terminate(ExitCode As Long) As Boolean
Attribute Terminate.VB_Description = "Abruptly ends the process."
Dim lngExitCode As Long

    If Not lngRunning = 0 Then
        If TerminateProcess(pi.hProcess, lngExitCode) Then
            Terminate = True
            ExitCode = lngExitCode
        Else
            RaiseError Err.LastDllError
        End If
    Else
        RaiseEvent Error(vbObjectError + 2, "No process to terminate.")
    End If
End Function

Friend Sub StepExec()
Dim lngSize As Long
Dim lngProcess As Long
Dim lngRead As Long
Dim strBuffer As String

    lngSize = BytesPending(stdOut.hReadPipe)
    If lngSize > 0 Then
        strBuffer = String$(lngSize, vbNullChar)
        If ReadFile(stdOut.hReadPipe, ByVal strBuffer, lngSize, lngRead, ByVal 0) Then
            RaiseEvent ConsoleOutput(strBuffer)
        Else
            RaiseError Err.LastDllError
        End If
    End If
    lngSize = BytesPending(stdError.hReadPipe)
    If lngSize > 0 Then
        strBuffer = String$(lngSize, vbNullChar)
        If ReadFile(stdError.hReadPipe, ByVal strBuffer, lngSize, lngRead, ByVal 0) Then
            RaiseEvent ConsoleError(strBuffer)
        Else
            RaiseError Err.LastDllError
        End If
    End If
    Do Until strStdIn = ""
        If WriteFile(stdIn.hWritePipe, ByVal strStdIn, Len(strStdIn), lngRead, ByVal 0) Then
            strStdIn = Mid$(strStdIn, lngRead + 1)
        Else
            RaiseError Err.LastDllError
            strStdIn = ""
        End If
    Loop
    lngProcess = WaitForSingleObject(pi.hProcess, 0)
    If lngProcess = WAIT_OBJECT_0 Then
        colTimers.Remove "tmr" & CStr(lngRunning)
        KillTimer 0, lngRunning
        If CloseHandle(pi.hProcess) Then
        Else
            RaiseError Err.LastDllError
        End If
        If CloseHandle(pi.hThread) Then
        Else
            RaiseError Err.LastDllError
        End If
        If CloseHandle(stdOut.hReadPipe) Then
        Else
            RaiseError Err.LastDllError
        End If
        If CloseHandle(stdOut.hWritePipe) Then
        Else
            RaiseError Err.LastDllError
        End If
        If CloseHandle(stdError.hReadPipe) Then
        Else
            RaiseError Err.LastDllError
        End If
        If CloseHandle(stdError.hWritePipe) Then
        Else
            RaiseError Err.LastDllError
        End If
        If CloseHandle(stdIn.hReadPipe) Then
        Else
            RaiseError Err.LastDllError
        End If
        If CloseHandle(stdIn.hWritePipe) Then
        Else
            RaiseError Err.LastDllError
        End If
        GetExitCodeProcess pi.hProcess, lngProcess
        lngRunning = 0
        RaiseEvent ProcessComplete(lngProcess)
    End If
End Sub

Private Function BytesPending(ByVal hPipe As Long) As Long
Dim lngBytesAvail As Long
Dim lngBytesLeft As Long

    If PeekNamedPipe(hPipe, ByVal 0, 0, ByVal 0, lngBytesAvail, lngBytesLeft) Then
        BytesPending = lngBytesAvail
    Else
        BytesPending = 0
        RaiseError Err.LastDllError
    End If
End Function

Private Sub RaiseError(ByVal ErrorNumber As Long)
Dim strBuffer As String
Dim lngSize As Long

    strBuffer = String$(2000, vbNullChar)
    lngSize = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or FORMAT_MESSAGE_IGNORE_INSERTS, ByVal 0, ErrorNumber, 0, strBuffer, Len(strBuffer), ByVal 0)
    strBuffer = Left$(strBuffer, lngSize)
    RaiseEvent Error(ErrorNumber, strBuffer)
End Sub

Private Sub Class_Initialize()

    If colTimers Is Nothing Then
        Set colTimers = New Collection
    End If
    lngRefs = lngRefs + 1
End Sub

Private Sub Class_Terminate()
    
    If Not lngRunning = 0 Then
        Call Me.Terminate(0)
        KillTimer 0, lngRunning
    End If
    lngRefs = lngRefs - 1
    If lngRefs = 0 Then
        Set colTimers = Nothing
    End If
End Sub
